package com.bergerkiller.bukkit.nolagg;

import java.util.Arrays;

import net.minecraft.server.MathHelper;

public class RemainderRate {
	
	private double contained = 0;
	private float roundedcontained = 0;
	private int counter = 0;
	private final int[] values = new int[10];
	public RemainderRate(double initialvalue) {
		this.set(initialvalue);
	}
	
	public void set(double value) {
		this.contained = value;
		if (Math.abs(value - this.roundedcontained) >= 0.1) {
			//set floor
			int floor = MathHelper.floor(value);
			Arrays.fill(this.values, floor);
			this.roundedcontained = floor;
			//get remainder (1.2 -> .2)
			floor = (int) ((value - floor) * 10);
			for (int i = 0; i < floor; i++) {
				this.values[i]++;
			}
		}
	}
	
	public int next() {
		counter++;
		if (counter > this.values.length - 1) {
			counter = 0;
		}
		return this.values[counter];
	}
	
	public double get() {
		return this.contained;
	}

}
