package com.bergerkiller.bukkit.nolagg.bufferedtag;

import java.io.DataInputStream;
import java.io.IOException;
import java.lang.reflect.Field;
import java.util.List;
import java.util.Map;

import net.minecraft.server.NBTTagList;

@SuppressWarnings({"rawtypes", "unchecked"})
public class NBTTagListBuffered extends NBTTagList {

	private static Field listfield;	
	private static Field typefield;
	
	public static NBTTagListBuffered readFrom(String name, final Map<String, byte[]> buffers, DataInputStream stream) throws IOException {
		try {
			if (listfield == null) {
				listfield = NBTTagList.class.getDeclaredField("list");
				listfield.setAccessible(true);
			}
			if (typefield == null) {
				typefield = NBTTagList.class.getDeclaredField("type");
				typefield.setAccessible(true);
			}
			byte type = stream.readByte();
			
			//create the object using reflection
			NBTTagListBuffered rval = new NBTTagListBuffered(name);
			typefield.set(rval, type);
			List list = (List) listfield.get(rval);

			//read data
            int i = stream.readInt();
            for (int j = 0; j < i; ++j) {
                list.add(NBTBaseBuffered.readFrom(type, null, buffers, stream));
            }
            
			return rval;
		} catch (Throwable t) {
			t.printStackTrace();
			return null;
		}
	}
	
	private NBTTagListBuffered(String name) {
		super(name);
	}
    
}
